#include "config.h"
#include <fcntl.h>
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/socket.h>
#ifdef HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>
#include "assert.h"
#include "io.h"
#include "io_internal.h"
#include "unix_defs.h"


static char test_byte = 'T';

extern void
establish_server_connection(iofile)
IOFile iofile;
{
    int sock;

    if ((iofile->server_fd == -1) || 
	(write(iofile->server_fd, &test_byte, 1) != 1)) {
	/* reestablish connection, name_str is the machine name */
	struct sockaddr_in sock_addr;
	struct hostent *host_addr;
	char *name_str = "aquarius.cc";
	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	    return;
	}
	sock_addr.sin_family = AF_INET;
	if ((host_addr = gethostbyname(name_str)) == NULL) {
	    return;
	}
	memcpy(&sock_addr.sin_addr, host_addr->h_addr, host_addr->h_length);
	sock_addr.sin_port = htons(FS_PORT);

	if (connect(sock, (struct sockaddr *) &sock_addr,
		    sizeof sock_addr) < 0) {
	    return;
	}
	iofile->server_fd = sock;
	server_write_header(iofile);
    }
}
	
extern void (*establish_server_connection_ptr)ARGS((IOFile iofile));

extern
IOContext
create_IOcontext(callback)
IOConversionCallbackFunc callback;
{
    IOFile iofile;

    /* fill in function pointer used in io_formats.c */
    establish_server_connection_ptr = establish_server_connection;

    iofile = new_IOFile();
    iofile->status = OpenNoHeader;
    iofile->IOversion = CURRENT_IO_VERSION;
    iofile->is_context = TRUE;
    iofile->conversion_callback = callback;
    reset_read_ahead(iofile);
    return (IOContext) iofile;
}

