typedef struct _first_rec {
    int integer_field;
    double double_field;
    char char_field;
} first_rec, *first_rec_ptr;

typedef struct _second_rec {
    int integer_field;
    short short_field;
    long long_field;
    char *string;
    double double_field;
    char char_field;
} second_rec, *second_rec_ptr;

typedef enum {Red_Stripe, Paulaner, Pilsner} enum_type;

typedef struct _third_rec {
    int integer_field;
    long long_field;
    unsigned int uint_field;
    unsigned long ulong_field;
    char *string;
    double double_field;
    char *string2;
    char char_field;
    enum_type enum_field;
} third_rec, *third_rec_ptr;

#define ARRAY_SIZE 14

typedef struct _fourth_rec {
    long	ifield;
    int		int_array[ARRAY_SIZE];
    double double_array[2][2];
} fourth_rec, *fourth_rec_ptr;

typedef struct _embedded_rec {
    short	ifield;
    char	*string;
    double	dfield;
} embedded_rec, *embedded_rec_ptr;

typedef struct _fifth_rec {
    embedded_rec earray[4];
} fifth_rec, *fifth_rec_ptr;

typedef struct _later_rec {
#if SIZEOF_LONG_LONG > SIZEOF_LONG
    long long integer_field;
#else
    long integer_field;
#endif
    char *string;
    double double_field;
} later_rec, *later_rec_ptr;

typedef struct _later_rec2 {
#if SIZEOF_LONG_LONG > SIZEOF_LONG
    long long integer_field;
#else
    long integer_field;
#endif
    double double_field;
    char *string;
} later_rec2, *later_rec2_ptr;

typedef struct _nested_rec {
    int integer_field;
    second_rec  nested_rec;
    char *string;
} nested_rec, *nested_rec_ptr;

typedef struct _sixth_rec {
    char	*string;
    long	icount;
#if SIZEOF_LONG_LONG > SIZEOF_LONG
    long long	*var_int_array;
#else
    long	*var_int_array;
#endif
    second_rec	*var_string_array;
    double	dfield;
    double	*var_double_array;
} sixth_rec, *sixth_rec_ptr;

extern IOField field_list[];
extern IOField field_list2[];
extern IOField field_list3[];
extern IOField field_list4[];
extern IOField embedded_field_list[];
extern IOField field_list5[];
extern IOField later_field_list[];
extern IOField later_field_list2[];
extern IOField nested_field_list[];
extern IOField field_list6[];

extern void init_written_data();

extern char *comment_array[];

extern first_rec rec1_array[13];

extern second_rec rec2_array[4];

extern third_rec rec3_array[5];

extern fourth_rec rec4;

extern fifth_rec rec5;

extern sixth_rec rec6_array[4];

extern nested_rec rec7_array[1];

extern later_rec rec8_array[3];

extern int second_rec_eq ARGS((second_rec *r1, second_rec *r2));
extern int third_rec_eq ARGS((third_rec *r1, third_rec *r2));
extern int fourth_rec_eq ARGS((fourth_rec *r1, fourth_rec *r2));
extern int emb_rec_eq ARGS((embedded_rec *r1, embedded_rec *r2));
extern int fifth_rec_eq ARGS((fifth_rec *r1, fifth_rec *r2));
extern int sixth_rec_eq ARGS((sixth_rec *r1, sixth_rec *r2));
extern int nested_rec_eq ARGS((nested_rec *r1, nested_rec *r2));
extern int later_rec_eq ARGS((later_rec *r1, later_rec *r2));

